/* vinit.c - Initialize "libv"
 *
 * Copyright (C) 1996  Jochen Voss.  */

static const  char  rcsid[] = "$Id: vinit.c 5044 2003-07-09 08:02:23Z voss $";

#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "v.h"


char **orig_argv;
int  orig_argc;
char **xargv;
int  xargc, xargv_len;
char *myname;

bool  interactive_flag;
bool  verbose_flag;


void
vinit (int argc, char **argv)
{
  interactive_flag = isatty (0);
  verbose_flag = FALSE;

  /* `basename' seems to be non-standard.  So we avoid it.  */
  myname = strrchr (argv[0], '/');
  myname = strdup (myname ? myname+1 : argv[0]);
  if (! myname)  fatal ("memory exhausted");
  
  xargc = orig_argc = argc;
  orig_argv = argv;
  xargv = xmalloc (argc*sizeof (char *));
  memcpy (xargv, argv, xargc*sizeof (char *));
}

void
vexit (void)
{
  vendopt ();
  xfree (xargv);
  xfree (myname);
}
